#include "bullet.h"
#include "player.h"
#include "colour.h"

std::list<Bullet*> bullets;

Bullet::Bullet (float _x) : x(_x), stage(0), flipped(false), hit(false) {
	if (x < 240) {
		vx = 1.5f;
		y = 30;
	} else {
		vx = -1.5f;
		y = 50;
	}
}

void Bullet::update () {
	x += vx;
	
	if (stage == 0) {
		if (vx > 0 && x >= 125) {
			stage = 1;
			
			if (phil->flip) { flipped = ! flipped; }
		} else if (vx < 0 && x <= 440 - 85) {
			stage = 1;
			
			if (john->flip) { flipped = ! flipped; }
		}
	} else if (stage == 1) {
		if (vx > 0 && x >= 440 - 85) {
			stage = 2;
			
			if (! john->flip) { flipped = ! flipped; }
		} else if (vx < 0 && x <= 125) {
			stage = 2;
			
			if (! phil->flip) { flipped = ! flipped; }
		}
	}
	
	if (vx > 0 && x >= 425) {
		hit = true;
		
		if (! flipped) { john->hit(); }
	} else if (vx < 0 && x <= 55) {
		hit = true;
		
		if (! flipped) { phil->hit(); }
	}
}

void Bullet::draw () const {
	Colour c(0, 0, 0);
	
	{//if (stage != 1) {
		if (vx > 0) {
			if (flipped) { c = johnColour; }
			else { c = philColour; }
		} else {
			if (flipped) { c = philColour; }
			else { c = johnColour; }
		}
	}
	
	glColor3ub(c.r, c.g, c.b);
	
	glVertex3f(x - 4, y + 5, 0);
	glVertex3f(x - 4, y, 0 );
	glVertex3f(x + 4, y, 0);
	glVertex3f(x + 4, y + 5, 0);
}

