#include "number.h"

Image* Number::image;

void Number::init () {
	image = new Image("images/numbers.png");
}

void Number::draw (float x, float y) const {
	glColor3f(1, 1, 1);
	glBindTexture(GL_TEXTURE_2D, image->texture);
	
	float t = 6.0f / 64.0f;
	
	float w = 30;
	float h = 40;
	
	bool drawZero = false;
	
	int digits = 1;
	
	if (number % 1000 >= 10) {
		digits = 2;
	}
	
	if (number % 1000 >= 100) {
		digits = 3;
	}
	
	x -= digits * w / 2;
	y -= h / 2;
	
	for (int i = 1000; i > 1; i /= 10) {
		int n = number % i;
		
		n = (n * 10) / i;
		
		if (! drawZero && i == 10) { drawZero = true; }
		
		if (n != 0 || drawZero) {
			drawZero = true;
			glBegin(GL_QUADS);
				glTexCoord2f(t*n, 0);	glVertex3f(x, y + h, 0);
				glTexCoord2f(t*n, 1); glVertex3f(x, y, 0 );
				glTexCoord2f(t*(n+1), 1); glVertex3f(x + w, y, 0);
				glTexCoord2f(t*(n+1), 0);	glVertex3f(x + w, y + h, 0);
			glEnd();
			
			x += w;
		}
	}
	
	glBindTexture(GL_TEXTURE_2D, 0);
}


